#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  LimeGreen
#property indicator_color2  PaleVioletRed
#property indicator_color3  Aqua
#property indicator_color4  Magenta
#property indicator_width1  2
#property indicator_style2  STYLE_DOT
#property indicator_width3  1
#property indicator_width4  1


//
//
//
//
//

extern int    FastPeriod      = 10;
extern int    FastPrice       = PRICE_CLOSE;
extern int    FastMethod      = MODE_EMA;
extern int    ProShift        = 2;
extern bool   ShowArrows      = false;

extern string note            = "turn on Alert = true; turn off = false";
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsEmail     = false;
extern string soundfile       = "alert.wav";

//
//
//
//
//

double fast[];
double pro[];
double UpArrow[];
double DnArrow[];
double trend[];
double EMAtempvar;

string emaresult;

datetime adxtime;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
      IndicatorBuffers(5);   
      SetIndexBuffer(0,fast);
      SetIndexBuffer(1,pro);
      SetIndexBuffer(2,UpArrow); 
      SetIndexBuffer(3,DnArrow); 
      SetIndexBuffer(4,trend);
      
      if (ShowArrows)
      {
         SetIndexStyle(2,DRAW_ARROW); SetIndexArrow(2,233);
         SetIndexStyle(3,DRAW_ARROW); SetIndexArrow(3,234);
      }
      else
      {
         SetIndexStyle(2,DRAW_NONE);
         SetIndexStyle(3,DRAW_NONE);
      }
      
      ObjectCreate("2mas",OBJ_LABEL,0,0,0);
      
      return(0);  
}  
int deinit() 
{ 
   ObjectDelete("2mas");      
   ObjectDelete("myHline3");
   ObjectDelete("myVline3");   
   
return(0);  
}  

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted(), last;
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   for(int i=limit; i>=0; i--)
   {
      fast[i] = iMA(NULL,0,FastPeriod,0,FastMethod ,FastPrice,i);
      pro[i]  = fast[i+ProShift];
      trend[i] = trend[i+1];
         if (fast[i]>pro[i]) trend[i] = 1;
         if (fast[i]<pro[i]) trend[i] =-1;
         
         UpArrow[i] = EMPTY_VALUE;
         DnArrow[i] = EMPTY_VALUE;
         if (trend[i] != trend[i+1]) 
         {
            EMAtempvar = iClose(NULL,0,i);      
            adxtime    = iTime(NULL,0,i);
            ObjectDelete("myHline3");
            ObjectDelete("myVline3");
            
            if (trend[i] == 1)
               UpArrow[i] = Low[i] - (Ask-Bid);
            else
               DnArrow[i] = High[i]+ (Ask-Bid);
          }
          if (trend[i] == 1)
            ObjectSetText("2mas",StringConcatenate("EMA: ", "Go Long @", " ", DoubleToStr(EMAtempvar ,Digits)," (", ((Close[0]-EMAtempvar)/Point)/1,   ")" ), 10, "Arial Black", Lime);
          else
            ObjectSetText("2mas",StringConcatenate("EMA: ", "Go Short @", " ", DoubleToStr(EMAtempvar ,Digits)," (", ((EMAtempvar-Close[0])/Point)/1,   ")" ), 10, "Arial Black", Red);
         
          ObjectSet("2mas",OBJPROP_XDISTANCE,2);
          ObjectSet("2mas",OBJPROP_YDISTANCE,3);
          ObjectSet("2mas", OBJPROP_CORNER, 3);
         
          if (trend[i] == 1 && last != 1) {
            last = 1;     
            ObjectCreate("myHline3", OBJ_HLINE, 0, adxtime, EMAtempvar, 0, 0);
            ObjectCreate("myVline3", OBJ_VLINE, 0, adxtime, EMAtempvar, 0, 0);
            ObjectSet("myHline3", OBJPROP_COLOR, Lime);
            ObjectSet("myVline3", OBJPROP_COLOR, Lime);   
            ObjectSet("myVline3", OBJPROP_STYLE, STYLE_DOT);   
            ObjectSet("myHline3", OBJPROP_STYLE, STYLE_DOT);
          }
          else if (trend[i] == -1 && last != -1) {
            last = -1;
            ObjectCreate("myHline3", OBJ_HLINE, 0, adxtime, EMAtempvar, 0, 0);
            ObjectCreate("myVline3", OBJ_VLINE, 0, adxtime, EMAtempvar, 0, 0);
            ObjectSet("myHline3", OBJPROP_COLOR, Red);
            ObjectSet("myVline3", OBJPROP_COLOR, Red);   
            ObjectSet("myHline3", OBJPROP_STYLE, STYLE_DOT);   
            ObjectSet("myVline3", OBJPROP_STYLE, STYLE_DOT);
            }
            
         }
         
         if (alertsOn)
         {
         if (alertsOnCurrent)
              int whichBar = 0;
         else     whichBar = 1;

         //
         //
         //
         //
         //
         
         if (trend[whichBar] != trend[whichBar+1])
         if (trend[whichBar] == 1)
               doAlert("uptrend");
         else  doAlert("downtrend");       
   }
   
   return(0);
}
//+------------------------------------------------------------------+


void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," 2mas ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," 2mas "),message);
             if (alertsSound)   PlaySound(soundfile);
      }
}

